﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace AuthorizationProject.Models
{
    using System.Reflection;

    using AuthorizationProject.Filter;

    public class SystemAction
    {
        /// <summary>
        /// 动作
        /// </summary>
        public string ActionName { get; set; }

        /// <summary>
        /// 控制器
        /// </summary>
        public string ControllerName { get; set; }

        /// <summary>
        /// 描述
        /// </summary>
        public string Description { get; set; }

        /// <summary>
        /// 链接地址
        /// </summary>
        public string LinkUrl { get; set; }
    }

    public class SystemConfig
    {
        public List<SystemAction> GetSystemActions()
        {
            var list = new List<SystemAction>();
            var types = Assembly.Load("AuthorizationProject").GetTypes().Where(b => b.BaseType != null && b.BaseType.Name == "BaseController");
            foreach (var type in types)
            {
                if (type.BaseType.Name == "BaseController")
                {
                    var attrs = type.GetCustomAttributes(typeof(System.ComponentModel.DescriptionAttribute), true);
                    var description = string.Empty;
                    if (attrs.Length > 0)
                    {
                        description = (attrs[0] as System.ComponentModel.DescriptionAttribute).Description;
                    }
                    list.Add(new SystemAction
                                 {
                                     ControllerName = type.Name.Replace("Controller", ""),
                                     Description = description,
                                 });
                }
            }
            return list;
        }
    }
}