﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace AuthorizationProject.Models
{
    using System.Web.Security;

    public class ValidateAuthorize
    {
        public bool validate(string controllerName)
        {
            HttpCookie authCookie = HttpContext.Current.Request.Cookies[FormsAuthentication.FormsCookieName];
            if (authCookie == null || authCookie.Value == "")
            {
                return false;
            }
            FormsAuthenticationTicket authTicket = null;
            try
            {
                authTicket = FormsAuthentication.Decrypt(authCookie.Value);
            }
            catch (Exception ex)
            {
                return false;
            }
            string[] prmissions = authTicket.UserData.Split(new char[] { ',' });

            return prmissions.Contains(controllerName);
        }

        public class SystemAuthorize
        {
            /// <summary>
            /// 动作
            /// </summary>
            public string ActionName { get; set; }

            /// <summary>
            /// 控制器
            /// </summary>
            public string ControllerName { get; set; }

            /// <summary>
            /// 描述
            /// </summary>
            public string Description { get; set; }
        }
    }
}